scriptName zzEstrusUtil

;;; Estrus API
;;;	EstrusEffectStopAPI(Actor akTarget)
;;;		stop estrus effect
;;;
;;;	EstrusEffectAPI(Actor akTarget, Int EffectType = 1, Int AnimType = 0, Int AnimPattern = 0, bool debugOn = false)
;;;		start estrus effect
;;;		EffectType:
;;;			1:	Estrus
;;;			2:	Estrus Self
;;;			3:	Estrus Undress
;;;		AnimType:
;;;			1:	Estrus Tentacle
;;;			2:	Estrus Etc
;;;			3:	Estrus Machine
;;;			99:	Random
;;;		AnimPattern:
;;;			0:	Random
;;;			1:	pattern1
;;;			2:	pattern2
;;;			3:	pattern3 (reserve)
;;;			...
;;;			6:	pattern6 (reserve)
;;;

function EstrusEffectStopAPI(Actor akTarget, bool debugOn = false) global

		Debug.TraceConditional("=================Estrus API abort(" + akTarget.GetActorBase().GetName() + akTarget + ")================", debugOn)
		akTarget.SetAnimationVariableInt("EstrusStop",1);
		return
endfunction

function EstrusEffectAPI(Actor akTarget, Int EffectType = 1, Int AnimType = 0, Int AnimPattern = 0, bool debugOn = false) global

	Debug.TraceConditional("=================Estrus API Start(" + akTarget.GetActorBase().GetName() + akTarget + ")================", debugOn)
	ObjectReference zzEstrusMarker = game.GetFormFromFile(0x01016c51, "zzEstrus.esp") as ObjectReference
	Spell zzEstrusEffectForAPI = game.GetFormFromFile(0x010166e6, "zzEstrus.esp") as spell
	Spell zzEstrusEffectSelfForAPI = game.GetFormFromFile(0x01016c55, "zzEstrus.esp") as spell
	Spell zzEstrusUndressForAPI = game.GetFormFromFile(0x01016c56, "zzEstrus.esp") as spell
	Miscobject zzEstrusToken = game.GetFormFromFile(0x01012b95, "zzEstrus.esp") as Miscobject
	Actor rPlayer = Game.GetForm(0x14) as Actor
	Spell rAPI;
	
	if(akTarget.getItemCount(zzEstrusToken) > 0)
		Debug.TraceConditional("=================Estrus API abort(" + akTarget.GetActorBase().GetName() + akTarget + ")================", debugOn)
		akTarget.SetAnimationVariableInt("EstrusStop",1);
		return
	EndIf
	
	akTarget.SetAnimationVariableInt("EstrusType",AnimType);
	akTarget.SetAnimationVariableInt("EstrusSet" ,AnimPattern);
	
	if(EffectType == 1)
		rAPI = zzEstrusEffectForAPI
	elseIf(EffectType == 2)
		rAPI = zzEstrusEffectSelfForAPI
	elseif(EffectType == 3)
		rAPI = zzEstrusUndressForAPI
	else
		Debug.TraceConditional("=================Estrus API abort(" + akTarget.GetActorBase().GetName() + akTarget + ")================", debugOn)
		return
	EndIf
	
	zzEstrusMarker.MoveTo(akTarget)
	if((EffectType == 1 && akTarget != rPlayer) || (EffectType == 2 && akTarget == rPlayer))
		Debug.TraceConditional("=================Estrus API cast start(" + akTarget.GetActorBase().GetName() + akTarget + ")================", debugOn)
		rAPI.cast(zzEstrusMarker,akTarget)
		Utility.wait(2)
		Debug.TraceConditional("=================Estrus API cast finish(" + akTarget.GetActorBase().GetName() + akTarget + ")================", debugOn)
	; 2015.07.20 / Mod / Bug-Fix. Changing an if condition, 0 -> 3
;	Elseif(EffectType == 0)
	Elseif(EffectType == 3)
		Debug.TraceConditional("=================Estrus API cast start(" + akTarget.GetActorBase().GetName() + akTarget + ")================", debugOn)
		rAPI.cast(zzEstrusMarker,akTarget)
		Utility.wait(2)
		Debug.TraceConditional("=================Estrus API cast finish(" + akTarget.GetActorBase().GetName() + akTarget + ")================", debugOn)
	Else
		Debug.TraceConditional("=================Estrus API abort(" + akTarget.GetActorBase().GetName() + akTarget + ")================", debugOn)
	EndIf
	
	akTarget.SetAnimationVariableInt("EstrusType",0);
	akTarget.SetAnimationVariableInt("EstrusSet" ,0);
	akTarget.SetAnimationVariableInt("EstrusStop",0);
	
	Debug.TraceConditional("=================Estrus API Finish(" + akTarget.GetActorBase().GetName() + akTarget + ")================", debugOn)
EndFunction

Bool function IsPlayableItem(Form item) global native
String function GetTriFilePath(Actor akActor, Int type) global native
function SwitchTriFiles(Actor akActor, String headPath, String eyesPath, String browsPath) global native
TextureSet function GetDefaultSkinTextureSet(ArmorAddon thisArmorAddon, Bool bFemale) global native
Float function GetCurrentFOV() global native
Float function GetDefaultFOV() global native
function SetCurrentFOV(Float fov) global native
function SetGlobalTimeMultiplier(Float ratio) global native
function SetUFOCamSpeedMult(Float ratio) global native
function StartFlyCam() global native
function StopFlyCam() global native
function ToggleFlyCam() global native
function TogglePause() global native

ObjectReference function test1(Actor akActor) global native
ObjectReference function GetFurnitureReference(Actor akActor) global native

Idle function getCurrentIdle(Actor akActor) global native